<id>
Quick PM
</id>

<version>
1.0
</version>

<mod info>
Creates a popup dialog with subject and message beneath a QuickLinked username for sending PMs without first going to the user's profile or the PM post page.

To Apply Mod:
1. Move ajax.js and YaBB.js from public_html/yabbfiles to cgi-bin/yabb2 (in with YaBB.pl)
2. Move default.css from public_html/yabbfiles/Templates/Forum to cgi-bin/yabb2 as well.
3. Apply modification
4. Move the 3 files above back to their original folders.
</mod info>

<author>
Unilat
</author>

<homepage>

</homepage>

<edit file>
Sources/InstantMessage.pl
</edit file>

<search for>
	if ($FORM{'dontstoreinoutbox'}) { $yySetLocation = qq~$scripturl?action=im~; }
	elsif ($FORM{'draft'}) { $yySetLocation = qq~$scripturl?action=imdraft~; }
	else { $yySetLocation = qq~$scripturl?action=imoutbox~; }
	&redirectexit;
</search for>

<replace>
	if (!$INFO{'quickpm'}) {
		if ($FORM{'dontstoreinoutbox'}) { $yySetLocation = qq~$scripturl?action=im~; }
		elsif ($FORM{'draft'}) { $yySetLocation = qq~$scripturl?action=imdraft~; }
		else { $yySetLocation = qq~$scripturl?action=imoutbox~; }
		&redirectexit;
	}
	die ""; # This is here only to avoid server error log entries!
</replace>

<edit file>
Sources/Load.pl
</edit file>

<search for>
	if ($iamguest) { return ($_[1] ? ${$uid.$user}{'realname'} : $format{$user}); }
</search for>

<add after>
	my ($quickpm,$quickpmlink);
</add after>

<search for>
		my $display = "display:inline";
		if ($ENV{'HTTP_USER_AGENT'} =~ /opera/i) {
			$display = "display:inline-block";
		} elsif ($ENV{'HTTP_USER_AGENT'} =~ /firefox/i) {
			$display = "display:inline-block";
</search for>

<replace>
		my $display = "display:inline-block";
		if ($ENV{'HTTP_USER_AGENT'} =~ /MSIE/i) {
			$display = "display:inline";
</replace>

<search for>
				$quicklinks .= qq~				<li><a href="$scripturl?action=imsend;to=$useraccount{$user}">$maintxt{'0'} ${$uid.$user}{'realname'}</a></li>\n~;
</search for>

<add after>
				$quickpmlink = qq~				<li><a href="javascript://" onclick="javascript:showQuickMessage('$qlcount');closeLinks('$useraccount{$user}$qlcount');">$maintxt{'0a'}</a></li>\n~;
				$quickpm = qq~
				<table cellpadding="2" cellspacing="0" border="0">
				<tr>
				<td>Subject:</td>
				<td><input style="float:left;" type="textbox" id="quickpmsub$qlcount"><input type="hidden" id="quickpmto$qlcount" value="$useraccount{$user}"></td>
				<td><a style="float:left;" href="javascript:QuickMessage('$scripturl?action=imsend2','$qlcount')">Send</a></td>
				</tr><tr>
				<td>Message:</td>
				<td><input type="textbox" id="quickpmmes$qlcount"></td>
				<td><a href="javascript:closeObject('quickpm$qlcount')">Close</a></td>
				</tr>
				</table>~;
				$quickpm = &createDialog($quickpm,280);
</add after>

<search for>
		$quicklinks .= qq~			</ul><a href="javascript:quickLinks('$useraccount{$user}$qlcount')"$lastonline>~;
</search for>

<replace>
		$quicklinks .= qq~$quickpmlink~;
		$quicklinks .= qq~			</ul>$quickpm<a href="javascript:quickLinks('$useraccount{$user}$qlcount')"$lastonline>~;

</replace>

<search for>
	} else {
		qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user}"$lastonline>~ . ($_[1] ? ${$uid.$user}{'realname'} : $format{$user}) . qq~</a>~;
	}
}

</search for>

<add after>
sub createDialog {
	my ($inner,$width) = @_;
	qq~
	<table width="$width" cellpadding="0" cellspacing="0" border="0" id="quickpm$qlcount" class="QuickPM" style="border-collapse: collapse;">
		<tr>
		  <td colspan="3"><img style="padding-left:1px" src="$imagesdir/bubblearrow.gif"></td>
		</tr>
		<tr>
		  <td width="7" style="background-image:url($imagesdir/bubblel.gif);"></td>
		  <td style="background-image:url($imagesdir/bubblet.gif);"></td>
		  <td width="5"><img src="$imagesdir/bubbletright.gif"></td>
		</tr>
		<tr>
		  <td width="5" style="background-image:url($imagesdir/bubblel.gif);"></td>
		  <td class="QuickPMcells">
		      $inner
		  </td>
		  <td width="5" style="background-image:url($imagesdir/bubbler.gif);"></td>
		</tr>
		<tr>
		  <td width="7"><img src="$imagesdir/bubblebleft.gif"></td>
		  <td style="background-image:url($imagesdir/bubbleb.gif);"></td>
		  <td width="5"><img src="$imagesdir/bubblebright.gif"></td>
		</tr>
	</table>\n~;
}

</add after>

<edit file>
ajax.js
</edit file>

<search for>
var imagedir = '';
</search for>

<add after>
var number = 0;
</add after>

<search for>
				links[i].innerHTML = addnotlink;
			}
		}
 	} 
}
</search for>

<add after>
function QuickMessage(url,id) {
	GetXmlHttpObject();
	if (xmlHttp == null) {
		alert("Ajax is not enabled, use default PM system");
		return;
	}
	number = id;
	var params = "toshow=" + document.getElementById("quickpmto" + id).value;
	params += "&subject=" + document.getElementById("quickpmsub" + id).value;
	params += "&message=" + document.getElementById("quickpmmes" + id).value;
	params += "&formsession=" + document.getElementsByName("formsession")[0].value;

	xmlHttp.onreadystatechange=returnQuickMessage;
	xmlHttp.open("POST",url + ";quickpm=1;random=" + Math.random(),true);
	xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	xmlHttp.setRequestHeader("Content-length", params.length);
	xmlHttp.setRequestHeader("Connection", "close");
	xmlHttp.send(params);
}

function returnQuickMessage() {
	if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete") {
		document.getElementById("quickpm" + number).style.display = "none";
 	}
}

function showQuickMessage(id) {
	document.getElementById("quickpm" + id).style.display = "block";
	document.getElementById("quickpmsub" + id).value = "";
	document.getElementById("quickpmmes" + id).value = "";
}

function closeObject(id) {
	document.getElementById(id).style.display = "none";
}

</add after>

<edit file>
YaBB.js
</edit file>

<search for>
	closeLinks(lastOpen);
	document.getElementById("ql"+num).style.display = "inline-block";
</search for>

<replace>
	closeLinks(lastOpen);
	document.getElementById("ql"+num).style.display = "block";
</replace>

<edit file>
default.css
</edit file>

<search for>
.QuickLinks a:hover {
	text-decoration:none;
}
</search for>

<add after>
.QuickPM {
	position: absolute;
	display: none;
	margin-top: 15px;
	margin-left: 0px;
	padding: 0px;
	border: 0px;
}
.QuickPMcells {
	background-color: #d2e9f7;
}
</add after>

<edit file>
Languages/English/Main.lng
</edit file>

<search for>
'0' => 'Send PM to',
</search for>

<add after>
'0a'=> 'Quick PM',
</add after>